using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WindowsApplication_TService.net.terraservice.www;
using System.IO;
using System.Drawing.Imaging;
using System.Globalization;

namespace WindowsApplication_TService
{
    public partial class F_TerraService : Form
    {
        public F_TerraService()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            LonLatPt center = new LonLatPt();
            //Int32 theme = new Theme();	// Version 2.0 change to int
            Scale scale = new Scale();
            Int32 imageWidth = 400;
            Int32 mapWidth = imageWidth;
            Int32 imageHeight = 200; 
            Int32 mapHeight = imageHeight;

            center.Lon = -121.821441650390063;
            center.Lat = 37.698287963867188;
            Int32 theme = 1;		// Version 2.0 change to integer value from Theme.Photo
            scale = (Scale)10;
            mapWidth = 400;
            mapHeight = 200;
            TerraService ts = new TerraService();
           
            AreaBoundingBox abb = ts.GetAreaFromPt(center, theme, scale, mapWidth, mapHeight);

            // Construct the bitmap represeting the full composite image
            PixelFormat pf = PixelFormat.Format24bppRgb;
            Image compositeImage = new Bitmap(imageWidth, imageHeight, pf);
            Graphics compositeGraphics = Graphics.FromImage(compositeImage);


            Int32 xStart = abb.NorthWest.TileMeta.Id.X;
            Int32 yStart = abb.NorthWest.TileMeta.Id.Y;
            for (Int32 x = xStart; x <= abb.NorthEast.TileMeta.Id.X; x++)
            {
                for (Int32 y = yStart; y >= abb.SouthWest.TileMeta.Id.Y; y--)
                {
                    TileId tid = abb.NorthWest.TileMeta.Id;
                    tid.X = x;
                    tid.Y = y;
                    Image tileImage = Image.FromStream(new MemoryStream(ts.GetTile(tid)));
                    compositeGraphics.DrawImage(tileImage,
                        (x - xStart) * tileImage.Width - (Int32)abb.NorthWest.Offset.XOffset,
                        (yStart - y) * tileImage.Height - (Int32)abb.NorthWest.Offset.YOffset,
                        tileImage.Width, tileImage.Height);
                    tileImage.Dispose();
                }
            }
            Int32 gridWidth = 3;
            // Draw the tile grid lines
            if (gridWidth != 0)
            {				             
                Color gridColor = Color.FromArgb(Int32.Parse("800000ff", NumberStyles.HexNumber | NumberStyles.AllowHexSpecifier));
                Pen pen = new Pen(gridColor, gridWidth);
                for (Int32 x = xStart; x <= abb.NorthEast.TileMeta.Id.X; x++)
                {
                    Int32 xCoord = (x - xStart) * 200 - (Int32)abb.NorthWest.Offset.XOffset;
                    compositeGraphics.DrawLine(pen, new Point(xCoord, 0), new Point(xCoord, mapHeight));
                }
                for (Int32 y = yStart; y >= abb.SouthWest.TileMeta.Id.Y; y--)
                {
                    Int32 yCoord = (yStart - y) * 200 - (Int32)abb.NorthWest.Offset.XOffset;
                    compositeGraphics.DrawLine(pen, new Point(0, yCoord), new Point(mapWidth, yCoord));
                }
            }
            pictureBoxImage.Image = compositeImage;
        }
    }
}